// RS232_ExamView.cpp : implementation of the CRS232_ExamView class
//

#include "stdafx.h"
#include "RS232_Exam.h"

#include "RS232_ExamDoc.h"
#include "RS232_ExamView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRS232_ExamView

IMPLEMENT_DYNCREATE(CRS232_ExamView, CFormView)

BEGIN_MESSAGE_MAP(CRS232_ExamView, CFormView)
	//{{AFX_MSG_MAP(CRS232_ExamView)
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, OnButtonClose)
	ON_BN_CLICKED(IDC_BUTTON_SET_V, OnButtonSetV)
	ON_BN_CLICKED(IDC_BUTTON_SET_STATE, OnButtonSetState)
	ON_BN_CLICKED(IDC_BUTTON_SET_REM, OnButtonSetRem)
	ON_BN_CLICKED(IDC_BUTTON_SET_CM, OnButtonSetCm)
	ON_BN_CLICKED(IDC_BUTTON_GET_V, OnButtonGetV)
	ON_BN_CLICKED(IDC_BUTTON_GET_CURRENT, OnButtonGetCurrent)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)

	ON_MESSAGE(WM_READ_DATA,OnReadData)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRS232_ExamView construction/destruction

CRS232_ExamView::CRS232_ExamView()
	: CFormView(CRS232_ExamView::IDD)
{
	//{{AFX_DATA_INIT(CRS232_ExamView)
	m_nAddress = 0;
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_pSerialPort = NULL;
}

CRS232_ExamView::~CRS232_ExamView()
{
	if(m_pSerialPort){
		delete m_pSerialPort;
		m_pSerialPort = NULL;
	}
}

void CRS232_ExamView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRS232_ExamView)
	DDX_Text(pDX, IDC_EDIT_ADDRESS, m_nAddress);
	//}}AFX_DATA_MAP
}

BOOL CRS232_ExamView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CRS232_ExamView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	if(m_pSerialPort == NULL){
		m_pSerialPort = new CSerialPort;
		m_pSerialPort->SetMessageHandle(m_hWnd,WM_READ_DATA);
	}
	SetDlgItemText(IDC_EDIT_COM,"1");
	SetDlgItemText(IDC_EDIT_BPS,"9600");

	CComboBox* pc = (CComboBox*)GetDlgItem(IDC_COMBO_CM);
	if(pc && pc->GetSafeHwnd()){
		pc->SetCurSel(0);
	}

	CButton* pb = (CButton*)GetDlgItem(IDC_RADIO_ON);
	if(pb && pb->GetSafeHwnd()) pb->SetCheck(1);
	pb = (CButton*)GetDlgItem(IDC_RADIO_OFF);
	if(pb && pb->GetSafeHwnd()) pb->SetCheck(0);

}

/////////////////////////////////////////////////////////////////////////////
// CRS232_ExamView printing

BOOL CRS232_ExamView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CRS232_ExamView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CRS232_ExamView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CRS232_ExamView::OnPrint(CDC* pDC, CPrintInfo* /*pInfo*/)
{
	// TODO: add customized printing code here
}

/////////////////////////////////////////////////////////////////////////////
// CRS232_ExamView diagnostics

#ifdef _DEBUG
void CRS232_ExamView::AssertValid() const
{
	CFormView::AssertValid();
}

void CRS232_ExamView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CRS232_ExamDoc* CRS232_ExamView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CRS232_ExamDoc)));
	return (CRS232_ExamDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRS232_ExamView message handlers
//
void CRS232_ExamView::OnReadData(WPARAM wParam,LPARAM lParam)
{
	memset(m_buffer,0,_MAX_PATH);
	char* p = (char*)lParam;
	if(p == NULL) return;
	int port = LOBYTE(wParam);
	int len = HIBYTE(wParam);
	memcpy(m_buffer,p,len);
	TRACE("յڵ, = %d",len);
	TRACE("\r\n");
	ShowData(IDC_EDIT_DATA_READ,m_buffer,len);
	Parse(m_buffer,len);
	UpdateData(FALSE);
}

//͵õ
void CRS232_ExamView::Parse(unsigned char* buf,int len)
{
	if(buf == NULL || len <= 0) return;

	CString str;
	BYTE cmd_write = m_buffer_write[2];

	if( cmd_write == Command_Constant_Current_Get ||
		cmd_write == Command_Constant_Voltage_Get ||
		cmd_write == Command_Constant_Power_Get ||
		cmd_write == Command_Constant_Resistance_Get )
	{
		float rate = 0.001f;
		if(cmd_write == Command_Constant_Current_Get) rate = 0.0001f;
		WORD lo = MAKEWORD(buf[3],buf[4]);
		WORD hi = MAKEWORD(buf[5],buf[6]);
		DWORD tmp = MAKELONG(lo,hi);
		float v = (float)(tmp * rate);
		str.Format("%f",v);
		SetDlgItemText(IDC_EDIT_VALUE,str);
	}
	else if(cmd_write == Command_Realtime_Get)
	{
		//ʵѹֵ
		WORD lo = MAKEWORD(buf[3],buf[4]);
		WORD hi = MAKEWORD(buf[5],buf[6]);
		DWORD tmp = MAKELONG(lo,hi);
		float v = (float)(tmp * 0.001);
		str.Format("%f",v);
		SetDlgItemText(IDC_EDIT_CURRENT_VALUE,str);
		//ʵֵ
		lo = MAKEWORD(buf[7],buf[8]);
		hi = MAKEWORD(buf[9],buf[10]);
		tmp = MAKELONG(lo,hi);
		v = (float)(tmp * 0.0001);
		str.Format("%f",v);
		SetDlgItemText(IDC_EDIT_CURRENT_VALUE_A,str);
		//ʵ빦ֵ
		lo = MAKEWORD(buf[11],buf[12]);
		hi = MAKEWORD(buf[13],buf[14]);
		tmp = MAKELONG(lo,hi);
		v = (float)(tmp * 0.001);
		TRACE("ǰ = %f\r\n",v);
	}
}

void CRS232_ExamView::OnButtonOpen() 
{
	UpdateData(TRUE);
	CString str;
	GetDlgItemText(IDC_EDIT_COM,str);
	char buf[10]={0};
	lstrcpy(buf,str);
	int port = atoi(buf);
	memset(buf,0,10);
	GetDlgItemText(IDC_EDIT_BPS,str);
	lstrcpy(buf,str);
	unsigned long bps = (unsigned long)atol(buf);
	if(m_pSerialPort->InitPort(m_hWnd,port,bps)){
		MessageBox("ڴ򿪳ɹ!","OK",MB_ICONINFORMATION);
	}else MessageBox("ڴʧ!","ERR",MB_ICONERROR);
}

void CRS232_ExamView::OnButtonClose() 
{
	if(m_pSerialPort == NULL) return;
	m_pSerialPort->ClosePort();
}

void CRS232_ExamView::OnButtonSetRem() 
{
	UpdateData(TRUE);
	if(m_pSerialPort == NULL) return;

	unsigned char tmp[100]={0};
	tmp[0] = 0xaa;
	tmp[1] = m_nAddress;
	tmp[2] = Command_Set_Remote;
	tmp[3] = 1;
	tmp[25] = GetChecksum(tmp,25);

	m_pSerialPort->WriteToPort((char*)&tmp[0],26);
	memset(m_buffer_write,0,_MAX_PATH);
	memcpy(m_buffer_write,tmp,26);
	ShowData(IDC_EDIT_DATA_WRITE,m_buffer_write,26);
	::SetDlgItemText(m_hWnd,IDC_EDIT_DATA_READ,"");
	UpdateData(FALSE);
}

void CRS232_ExamView::OnButtonSetState() 
{
	UpdateData(TRUE);
	if(m_pSerialPort == NULL) return;
	BOOL ON = FALSE;
	CButton* pb = (CButton*)GetDlgItem(IDC_RADIO_ON);
	if(pb && pb->GetSafeHwnd()) ON = pb->GetCheck() != 0;
	pb = (CButton*)GetDlgItem(IDC_RADIO_OFF);
	if(pb && pb->GetSafeHwnd()) ON = pb->GetCheck() == 0;

	unsigned char tmp[100]={0};
	tmp[0] = 0xaa;
	tmp[1] = m_nAddress;
	tmp[2] = Command_Set_Output_State;
	tmp[3] = ON ? 1:0;
	tmp[25] = GetChecksum(tmp,25);
	
	m_pSerialPort->WriteToPort((char*)&tmp[0],26);
	memset(m_buffer_write,0,_MAX_PATH);
	memcpy(m_buffer_write,tmp,26);
	ShowData(IDC_EDIT_DATA_WRITE,m_buffer_write,26);
	::SetDlgItemText(m_hWnd,IDC_EDIT_DATA_READ,"");
	UpdateData(FALSE);
}

void CRS232_ExamView::OnButtonSetCm() 
{
	UpdateData(TRUE);
	if(m_pSerialPort == NULL) return;
	int idx=0;
	CComboBox* pc = (CComboBox*)GetDlgItem(IDC_COMBO_CM);
	if(pc && pc->GetSafeHwnd()){
		idx = pc->GetCurSel();
	}
	unsigned char tmp[100]={0};
	tmp[0] = 0xaa;
	tmp[1] = m_nAddress;
	tmp[2] = Command_Constant_Mode_Set;
	tmp[3] = idx;
	tmp[25] = GetChecksum(tmp,25);

	m_pSerialPort->WriteToPort((char*)&tmp[0],26);
	memset(m_buffer_write,0,_MAX_PATH);
	memcpy(m_buffer_write,tmp,26);
	ShowData(IDC_EDIT_DATA_WRITE,m_buffer_write,26);
	::SetDlgItemText(m_hWnd,IDC_EDIT_DATA_READ,"");
	UpdateData(FALSE);
}

void CRS232_ExamView::OnButtonSetV() 
{
	UpdateData(TRUE);
	if(m_pSerialPort == NULL) return;
	int idx=0;
	CComboBox* pc = (CComboBox*)GetDlgItem(IDC_COMBO_CM);
	if(pc && pc->GetSafeHwnd()){
		idx = pc->GetCurSel();
	}

	CString str;
	GetDlgItemText(IDC_EDIT_VALUE,str);
	float v = (float)atof(str);

	unsigned char tmp[100]={0};
	tmp[0] = 0xaa;
	tmp[1] = m_nAddress;

	float rate = 1000.0f;
	if(idx == 0){
		tmp[2] = Command_Constant_Current_Set;
		rate = 10000.0f;
	}
	else if(idx == 1) tmp[2] = Command_Constant_Voltage_Set;
	else if(idx == 2) tmp[2] = Command_Constant_Power_Set;
	else if(idx == 0) tmp[2] = Command_Constant_Resistance_Set;

	DWORD dwv = (DWORD)(v * rate);
	//45
	if((v * rate) - (double)dwv >= 0.5) dwv++;
	tmp[3] = LOBYTE(LOWORD(dwv));
	tmp[4] = HIBYTE(LOWORD(dwv));
	tmp[5] = LOBYTE(HIWORD(dwv));
	tmp[6] = HIBYTE(HIWORD(dwv));

	tmp[25] = GetChecksum(tmp,25);

	m_pSerialPort->WriteToPort((char*)&tmp[0],26);
	memset(m_buffer_write,0,_MAX_PATH);
	memcpy(m_buffer_write,tmp,26);
	ShowData(IDC_EDIT_DATA_WRITE,m_buffer_write,26);
	::SetDlgItemText(m_hWnd,IDC_EDIT_DATA_READ,"");
	UpdateData(FALSE);
}

//õ趨ֵ
void CRS232_ExamView::OnButtonGetV() 
{
	UpdateData(TRUE);
	int idx=0;
	CComboBox* pc = (CComboBox*)GetDlgItem(IDC_COMBO_CM);
	if(pc && pc->GetSafeHwnd()){
		idx = pc->GetCurSel();
	}

	unsigned char tmp[100]={0};
	tmp[0] = 0xaa;
	tmp[1] = m_nAddress;
	
	if(idx == 0) tmp[2] = Command_Constant_Current_Get;
	else if(idx == 1) tmp[2] = Command_Constant_Voltage_Get;
	else if(idx == 2) tmp[2] = Command_Constant_Power_Get;
	else if(idx == 0) tmp[2] = Command_Constant_Resistance_Get;
	
	tmp[25] = GetChecksum(tmp,25);

	m_pSerialPort->WriteToPort((char*)&tmp[0],26);
	memset(m_buffer_write,0,_MAX_PATH);
	memcpy(m_buffer_write,tmp,26);
	ShowData(IDC_EDIT_DATA_WRITE,m_buffer_write,26);
	::SetDlgItemText(m_hWnd,IDC_EDIT_DATA_READ,"");
	UpdateData(FALSE);
}

void CRS232_ExamView::OnButtonGetCurrent() 
{
	UpdateData(TRUE);
	unsigned char tmp[100]={0};
	tmp[0] = 0xaa;
	tmp[1] = m_nAddress;
	tmp[2] = Command_Realtime_Get;
	tmp[25] = GetChecksum(tmp,25);

	m_pSerialPort->WriteToPort((char*)&tmp[0],26);
	memset(m_buffer_write,0,_MAX_PATH);
	memcpy(m_buffer_write,tmp,26);
	ShowData(IDC_EDIT_DATA_WRITE,m_buffer_write,26);
	::SetDlgItemText(m_hWnd,IDC_EDIT_DATA_READ,"");
	UpdateData(FALSE);
}

void CRS232_ExamView::ShowData(UINT id,const unsigned char* buf,int len)
{
	if(buf == NULL) return;
	char tmp[_MAX_PATH]={0};
	char xx[10];
	for(int i=0;i<len;i++){
		sprintf(xx,"%02X ",buf[i]);
		strcat(tmp,xx);
	}
	::SetDlgItemText(m_hWnd,id,tmp);
}

