/*
**	ļ				CSerialPort.cpp
**
**	ô				Զдһ.
**						¼ʱϼϢ
**						һһֱеĴڲ߳д
*/

#include "stdafx.h"
#include <assert.h>
#include <stdlib.h>
#include "SerialPort.h"

//
// Constructor
//
CSerialPort::CSerialPort()
{
	m_hComm = NULL;
//	m_Thread=NULL;
	m_HReceiveThread=NULL;

	// initialize overlapped structure members to zero
	m_ov.Offset = 0;
	m_ov.OffsetHigh = 0;

	// create events
	m_ov.hEvent = NULL;
	m_hWriteEvent = NULL;
	m_hShutdownEvent = NULL;

	for(int i=0;i<_MAX_PATH;i++)
	{
		m_szWriteBuffer[i]=0;
		m_szReadBuffer[i]=0;
	}

	m_bThreadAlive = FALSE;
	m_nWriteDataLength=0;
	m_hOwnerWnd=NULL;
	m_dwMessage=NULL;
}

//
// Delete dynamic memory
//
CSerialPort::~CSerialPort()
{
	if(m_hShutdownEvent!=NULL)
		SetEvent(m_hShutdownEvent);
	//߳ûйص,Ҫǿƹر
	if(m_bThreadAlive)
	{
		DWORD ReceiveThreadExitCode=0;
		if(m_HReceiveThread != NULL)
		{
			::GetExitCodeThread(m_HReceiveThread,&ReceiveThreadExitCode);
			if(ReceiveThreadExitCode == STILL_ACTIVE)
				::SuspendThread(m_HReceiveThread);//߳
			::TerminateThread(m_HReceiveThread,ReceiveThreadExitCode);
			m_HReceiveThread = NULL;
			TRACE("߳˳\n");
		}

		m_bThreadAlive=FALSE;
	}

	m_hShutdownEvent=NULL;

	if (m_hComm!=NULL) CloseHandle(m_hComm);
	TRACE("Thread ended\n");
}

void CSerialPort::ClosePort()
{
	if(m_hShutdownEvent!=NULL)
		SetEvent(m_hShutdownEvent);
	if(m_bThreadAlive)
	{
		DWORD ReceiveThreadExitCode=0;
		if(m_HReceiveThread != NULL)
		{
			::GetExitCodeThread(m_HReceiveThread,&ReceiveThreadExitCode);
			if(ReceiveThreadExitCode == STILL_ACTIVE)
				::SuspendThread(m_HReceiveThread);//߳
			::TerminateThread(m_HReceiveThread,ReceiveThreadExitCode);
			m_HReceiveThread = NULL;
			TRACE("߳˳\n");
		}
		m_bThreadAlive=FALSE;
	}

	m_hShutdownEvent=NULL;

	if (m_hComm!=NULL) CloseHandle(m_hComm);
	m_hComm=NULL;
	TRACE("Thread ended\n");
}


//
// Initialize the port. This can be port 1 to 30.
//
BOOL CSerialPort::InitPort(HWND  hPortOwnerWnd,	// the owner (CWnd) of the port (receives message)
						   UINT  portnr,		// portnumber (1..4)
						   ULONG baud,			// baudrate
						   char  parity,		// parity 
						   UINT  databits,		// databits 
						   UINT  stopbits)		// stopbits 

{
	// if the thread is alive: Kill
	if (m_bThreadAlive)
	{
		do
		{
			SetEvent(m_hShutdownEvent);
		} while (m_bThreadAlive);
		TRACE("Thread ended\n");
	}

	// create events
	if (m_ov.hEvent != NULL)
		ResetEvent(m_ov.hEvent);
	m_ov.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

	if (m_hWriteEvent != NULL)
		ResetEvent(m_hWriteEvent);
	m_hWriteEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	
	if (m_hShutdownEvent != NULL)
		ResetEvent(m_hShutdownEvent);
	m_hShutdownEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

	// initialize the event objects
	m_hEventArray[0] = m_hShutdownEvent;	// highest priority
	m_hEventArray[1] = m_ov.hEvent;
	m_hEventArray[2] = m_hWriteEvent;

	// initialize critical section
	InitializeCriticalSection(&m_csCommunicationSync);
	
	// set buffersize for writing and save the owner
	m_hOwnerWnd = hPortOwnerWnd;

	for(int i=0;i<_MAX_PATH;i++)
	{
		m_szWriteBuffer[i]=0;
		m_szReadBuffer[i]=0;
	}

	m_nPortNum = portnr;

	BOOL bResult = FALSE;
	char *szPort = new char[50];
	char *szBaud = new char[50];

	// now it critical!
	EnterCriticalSection(&m_csCommunicationSync);

	// if the port is already opened: close it
	if (m_hComm != NULL)
	{
		CloseHandle(m_hComm);
		m_hComm = NULL;
	}

	// prepare port strings
	sprintf(szPort, "COM%d", portnr);
	CString str;str=_T("");
	str.Format("COM%d",portnr);
	str = "//./" + str;
	sprintf(szBaud, "baud=%d parity=%c data=%d stop=%d", baud, parity, databits, stopbits);

	// get a handle to the port
	m_hComm = CreateFile(str,						// communication port string (COMX)
					     GENERIC_READ | GENERIC_WRITE,	// read/write types
					     0,								// comm devices must be opened with exclusive access
					     NULL,							// no security attributes
					     OPEN_EXISTING,					// comm devices must use OPEN_EXISTING
					     FILE_FLAG_OVERLAPPED,			// Async I/O
					     0);							// template must be 0 for comm devices

	if (m_hComm == INVALID_HANDLE_VALUE)
	{
		// port not found
		delete [] szPort;
		delete [] szBaud;

		return FALSE;
	}

	// set the timeout values

	m_CommTimeouts.ReadIntervalTimeout=100; 
	m_CommTimeouts.ReadTotalTimeoutMultiplier=200; 
	m_CommTimeouts.ReadTotalTimeoutConstant=10; 
	m_CommTimeouts.WriteTotalTimeoutMultiplier=200; 
	m_CommTimeouts.WriteTotalTimeoutConstant=2;

	// configure
	if (SetCommTimeouts(m_hComm, &m_CommTimeouts))
	{						   
		if (SetCommMask(m_hComm, EV_RXCHAR))
		{
			if (GetCommState(m_hComm, &m_dcb))
			{
				m_dcb.fRtsControl=RTS_CONTROL_ENABLE; 
				if (BuildCommDCB(szBaud, &m_dcb))
				{
					if (SetCommState(m_hComm, &m_dcb))
						; // normal operation... continue
					else
						ProcessErrorMessage("SetCommState()");
				}
				else
					ProcessErrorMessage("BuildCommDCB()");
			}
			else
				ProcessErrorMessage("GetCommState()");
		}
		else
			ProcessErrorMessage("SetCommMask()");
	}
	else
		ProcessErrorMessage("SetCommTimeouts()");

	delete [] szPort;
	delete [] szBaud;

	// flush the port
	PurgeComm(m_hComm, PURGE_RXCLEAR | PURGE_TXCLEAR | PURGE_RXABORT | PURGE_TXABORT);

	// release critical section
	LeaveCriticalSection(&m_csCommunicationSync);

	EscapeCommFunction(m_hComm,CLRDTR);
	EscapeCommFunction(m_hComm,SETDTR);
	EscapeCommFunction(m_hComm,CLRRTS);
	EscapeCommFunction(m_hComm,SETRTS);

	TRACE("Initialisation for communicationport %d completed.\nUse Startmonitor to communicate.\n", portnr);

	StartMonitoring();
	return TRUE;
}

//
//  The CommThread Function.
//
//UINT CSerialPort::CommThread(LPVOID pParam)
DWORD _stdcall CSerialPort::CommThread(LPVOID pParam) 
{
	// Cast the void pointer passed to the thread back to
	// a pointer of CSerialPort class
	CSerialPort *port = (CSerialPort*)pParam;
	//߳б־	
	port->m_bThreadAlive = TRUE;	
		
	DWORD BytesTransfered = 0; 
	DWORD Event = 0;
	DWORD CommEvent = 0;
	DWORD dwError = 0;
	COMSTAT comstat;
	BOOL  bResult = TRUE;
	char RXbuff[_MAX_PATH];
	for(int i=0;i<_MAX_PATH;i++) RXbuff[i]=0;
	DWORD ByteRead=0;
		
	//ջжһв
	if (port->m_hComm)
		PurgeComm(port->m_hComm, PURGE_RXCLEAR | PURGE_TXCLEAR | PURGE_RXABORT | PURGE_TXABORT);

	for (;;) 
	{ 

		// Make a call to WaitCommEvent().  This call will return immediatly
		// because our port was created as an async port (FILE_FLAG_OVERLAPPED
		// and an m_OverlappedStructerlapped structure specified).  This call will cause the 
		// m_OverlappedStructerlapped element m_OverlappedStruct.hEvent, which is part of the m_hEventArray to 
		// be placed in a non-signeled state if there are no bytes available to be read,
		// or to a signeled state if there are bytes available.  If this event handle 
		// is set to the non-signeled state, it will be set to signeled when a 
		// character arrives at the port.

		// we do this for each port!

		bResult = WaitCommEvent(port->m_hComm, &Event, &port->m_ov);

		if (!bResult)  
		{ 
			// If WaitCommEvent() returns FALSE, process the last error to determin
			// the reason..
			switch (dwError = GetLastError()) 
			{ 
			case ERROR_IO_PENDING: 	
				{ 
					// This is a normal return value if there are no bytes
					// to read at the port.
					// Do nothing and continue
					break;
				}
			case 87:
				{
					// Under Windows NT, this value is returned for some reason.
					// I have not investigated why, but it is also a valid reply
					// Also do nothing and continue.
					break;
				}
			default:
				{
					// All other error codes indicate a serious error has
					// occured.  Process this error.
					port->ProcessErrorMessage("WaitCommEvent()");
					break;
				}
			}
		}
		else
		{
			// If WaitCommEvent() returns TRUE, check to be sure there are
			// actually bytes in the buffer to read.  
			//
			// If you are reading more than one byte at a time from the buffer 
			// (which this program does not do) you will have the situation occur 
			// where the first byte to arrive will cause the WaitForMultipleObjects() 
			// function to stop waiting.  The WaitForMultipleObjects() function 
			// resets the event handle in m_OverlappedStruct.hEvent to the non-signelead state
			// as it returns.  
			//
			// If in the time between the reset of this event and the call to 
			// ReadFile() more bytes arrive, the m_OverlappedStruct.hEvent handle will be set again
			// to the signeled state. When the call to ReadFile() occurs, it will 
			// read all of the bytes from the buffer, and the program will
			// loop back around to WaitCommEvent().
			// 
			// At this point you will be in the situation where m_OverlappedStruct.hEvent is set,
			// but there are no bytes available to read.  If you proceed and call
			// ReadFile(), it will return immediatly due to the async port setup, but
			// GetOverlappedResults() will not return until the next character arrives.
			//
			// It is not desirable for the GetOverlappedResults() function to be in 
			// this state.  The thread shutdown event (event 0) and the WriteFile()
			// event (Event2) will not work if the thread is blocked by GetOverlappedResults().
			//
			// The solution to this is to check the buffer with a call to ClearCommError().
			// This call will reset the event handle, and if there are no bytes to read
			// we can loop back through WaitCommEvent() again, then proceed.
			// If there are really bytes to read, do nothing and proceed.
		
			bResult = ClearCommError(port->m_hComm, &dwError, &comstat);

			if (comstat.cbInQue == 0)
				continue;
		}

		Event = WaitForMultipleObjects(3, port->m_hEventArray, FALSE, INFINITE);

		switch (Event)
		{
		case 0:
			{
				// Shutdown event.  This is event zero so it will be
				// the higest priority and be serviced first.
			 	port->m_bThreadAlive = FALSE;
				TRACE("յ˳¼\n");				
				// Kill this thread.  break is not needed, but makes me feel better.
				AfxEndThread(100);
				break;
			}
		case 1:	// read event
			{
				GetCommMask(port->m_hComm, &CommEvent);
				if ((CommEvent & EV_CTS)||(CommEvent & EV_RXFLAG)||(CommEvent & EV_BREAK)||
					(CommEvent & EV_ERR)||(CommEvent & EV_RING))
				{
				}
				if (CommEvent & EV_RXCHAR)
				{
					memset(RXbuff,0,_MAX_PATH);
					ReceiveChar(port, comstat,RXbuff,ByteRead);
				}
				break;
			}  
		case 2: // write event
			{
				WriteChar(port);
				break;
			}

		}

	}

	return 0;
}

//
// start comm watching
//
BOOL CSerialPort::StartMonitoring()
{//CREATE_SUSPENDED
	DWORD lpReceiveThreadId=0,lpTransmitThreadId=0;
	m_HReceiveThread = ::CreateThread(NULL,0,CommThread, this,
		0,&lpReceiveThreadId);//߳
	::SetThreadPriority(m_HReceiveThread,THREAD_PRIORITY_BELOW_NORMAL);

/*	if (!(m_Thread = AfxBeginThread(CommThread, this)))
	{
		m_Thread=NULL;
		return FALSE;
	}*/
	TRACE("Thread started\n");
	return TRUE;	
}

//
// Restart the comm thread
//
BOOL CSerialPort::RestartMonitoring()
{
	TRACE("Thread resumed\n");
//	if(m_Thread!=NULL)
//		m_Thread->ResumeThread();
	if(m_HReceiveThread!=NULL) ::ResumeThread(m_HReceiveThread);
	return TRUE;	
}


//
// Suspend the comm thread
//
BOOL CSerialPort::StopMonitoring()
{
	TRACE("Thread suspended\n");
//	if(m_Thread!=NULL)
//		m_Thread->SuspendThread(); 
	if(m_HReceiveThread!=NULL) ::SuspendThread(m_HReceiveThread);
	return TRUE;	
}


//
// If there is a error, give the right message
//
void CSerialPort::ProcessErrorMessage(char* ErrorText)
{
	char *Temp = new char[200];
	
	LPVOID lpMsgBuf;

	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL 
	);

	sprintf(Temp, "WARNING:  %s Failed with the following error: \n%s\nPort: %d\n", (char*)ErrorText, lpMsgBuf, m_nPortNum); 
//	MessageBox(NULL, Temp, "Application Error", MB_ICONSTOP);
	::OutputDebugString(Temp);
	::OutputDebugString("\n\n");

	LocalFree(lpMsgBuf);
	delete[] Temp;
}

//
// Write a character.
//
void CSerialPort::WriteChar(CSerialPort* port)
{
	BOOL bWrite = TRUE;
	BOOL bResult = TRUE;

	DWORD BytesSent = 0;

	ResetEvent(port->m_hWriteEvent);

	// Gain ownership of the critical section
	EnterCriticalSection(&port->m_csCommunicationSync);

	if (bWrite)
	{
		// Initailize variables
		port->m_ov.Offset = 0;
		port->m_ov.OffsetHigh = 0;

		// Clear buffer
//		PurgeComm(port->m_hComm, PURGE_RXCLEAR | PURGE_TXCLEAR | PURGE_RXABORT | PURGE_TXABORT);

		bResult = WriteFile(port->m_hComm,
							port->m_szWriteBuffer,
							port->m_nWriteDataLength,
							&BytesSent,
							&port->m_ov);
		// deal with any error codes
		if (!bResult)  
		{
			DWORD dwError = GetLastError();
			switch (dwError)
			{
				case ERROR_IO_PENDING:
					{
						// continue to GetOverlappedResults()
						BytesSent = 0;
						bWrite = FALSE;
						break;
					}
				default:
					{
						// all other error codes
						port->ProcessErrorMessage("WriteFile()");
					}
			}
		} 
		else
		{
			LeaveCriticalSection(&port->m_csCommunicationSync);
		}
	}

	if (!bWrite)
	{
		bWrite = TRUE;
	
		bResult = GetOverlappedResult(port->m_hComm,	// Handle to COMM port 
									  &port->m_ov,		// Overlapped structure
									  &BytesSent,		// Stores number of bytes sent
									  TRUE); 			// Wait flag

		LeaveCriticalSection(&port->m_csCommunicationSync);

		if (!bResult)  
		{
			port->ProcessErrorMessage("GetOverlappedResults() in WriteFile()");
		}	
	}

	if (BytesSent != port->m_nWriteDataLength)
	{
		TRACE("WARNING: WriteFile() error.. Bytes Sent: %d; Message Length: %d\n", BytesSent, port->m_nWriteDataLength);
	}
	PurgeComm(port->m_hComm, PURGE_RXCLEAR | PURGE_TXCLEAR | PURGE_RXABORT | PURGE_TXABORT);
	TRACE("COM%d,Write[%d,%d]\n",
		port->m_nPortNum,port->m_nWriteDataLength,BytesSent);
	CString str,str1;str=_T("");
	TRACE(":");
	TRACE(port->m_szWriteBuffer);
	TRACE("\r\n");
}

//
// Character received. Inform the owner
//
void CSerialPort::ReceiveChar(CSerialPort* port, COMSTAT comstat,char* RXbuff,DWORD ByteRead)
{
	BOOL  bRead = TRUE; 
	BOOL  bResult = TRUE;
	DWORD dwError = 0;
	//DWORD BytesRead = 0;
	//unsigned char RXBuff;
	char* buff;

	buff=RXbuff;

	for (;;) 
	{ 
		// Gain ownership of the comm port critical section.
		// This process guarantees no other part of this program 
		// is using the port object. 
		
		EnterCriticalSection(&port->m_csCommunicationSync);

		// ClearCommError() will update the COMSTAT structure and
		// clear any other errors.
		
		bResult = ClearCommError(port->m_hComm, &dwError, &comstat);

		LeaveCriticalSection(&port->m_csCommunicationSync);

		// start forever loop.  I use this type of loop because I
		// do not know at runtime how many loops this will have to
		// run. My solution is to start a forever loop and to
		// break out of it when I have processed all of the
		// data available.  Be careful with this approach and
		// be sure your loop will exit.
		// My reasons for this are not as clear in this sample 
		// as it is in my production code, but I have found this 
		// solutiion to be the most efficient way to do this.
		
		if (comstat.cbInQue == 0)
		{
			// break out when all bytes have been read
			break;
		}
						
		EnterCriticalSection(&port->m_csCommunicationSync);

		if (bRead)
		{
			bResult = ReadFile(port->m_hComm,		// Handle to COMM port 
							   buff,				// RX Buffer Pointer
							   _MAX_PATH,					// Read one byte
							   &ByteRead,			// Stores number of bytes read
							   &port->m_ov);		// pointer to the m_ov structure
			// deal with the error code 
			if (!bResult)  
			{ 
				switch (dwError = GetLastError()) 
				{ 
					case ERROR_IO_PENDING: 	
						{ 
							// asynchronous i/o is still in progress 
							// Proceed on to GetOverlappedResults();
							bRead = FALSE;
							ByteRead=0;
							break;
						}
					default:
						{
							// Another error has occured.  Process this error.
							port->ProcessErrorMessage("ReadFile()");
							break;
						} 
				}
			}
			else
			{
				// ReadFile() returned complete. It is not necessary to call GetOverlappedResults()
				bRead = TRUE;
			}
		}

		if (!bRead)
		{
			bRead = TRUE;
			bResult = GetOverlappedResult(port->m_hComm,	// Handle to COMM port 
										  &port->m_ov,		// Overlapped structure
										  &ByteRead,		// Stores number of bytes read
										  TRUE); 			// Wait flag

			if (!bResult)  
			{
				port->ProcessErrorMessage("GetOverlappedResults() in ReadFile()");
			}	
		}

		LeaveCriticalSection(&port->m_csCommunicationSync);

		// notify parent that a byte was received
		memcpy(port->m_szReadBuffer,buff,ByteRead);
		port->m_nReadDataLength=ByteRead;
		BYTE len=(BYTE)ByteRead;
		TRACE("COM%d,Receive[%d]:\n",port->m_nPortNum,len);
		TRACE(":");
		TRACE(buff);
		TRACE("\n\r");
		::SendMessage(port->m_hOwnerWnd,WM_READ_DATA,MAKEWORD(port->m_nPortNum,len),(LPARAM)buff);
	}

	PurgeComm(port->m_hComm, PURGE_RXCLEAR | PURGE_TXCLEAR | PURGE_RXABORT | PURGE_TXABORT);
}


void CSerialPort::WriteToPort(char* writebuffer,DWORD writelength)
{
	assert(m_hComm != 0);

	if(writebuffer==NULL) return;

	memcpy(m_szWriteBuffer,writebuffer,writelength);
	m_nWriteDataLength = writelength;
//	strcpy(m_szWriteBuffer, &string);

	// Clear buffer
	PurgeComm(m_hComm, PURGE_RXCLEAR | PURGE_TXCLEAR | PURGE_RXABORT | PURGE_TXABORT);

	// set event for write
	SetEvent(m_hWriteEvent);
}

int CSerialPort::ReceiveMessage(char* pPackage)
{
	if(pPackage==NULL) return 0;
	int len=m_nReadDataLength;
	memcpy(pPackage,m_szReadBuffer,m_nReadDataLength);
	m_nReadDataLength=0;
	memset(m_szReadBuffer,0,_MAX_PATH);
	return len;
}

void CSerialPort::SetMessageHandle(HWND hMsg,DWORD dwMsg)
{
	m_hOwnerWnd=hMsg;
	m_dwMessage=dwMsg;
}

